﻿-- Author      : Nogarder
-- Create Date : 2010/6/29 1:48:01
local NPA_Aura={}
local NPA_Aura_Frame={}

--config

local NPA_Aura_DefaultSetting={
		["Aura_BarData"]={
			OffsetX=0,
			OffsetY=0,
			Height=20,
			Width=20,
			Red=1,
			Green=1,
			Blue=1,
			Alpha=0.5,
			Texture="Interface\\TargetingFrame\\UI-StatusBar",
			TextureBlend="ADD",
			RAngle=90,
			DeepCheck=1,
			Top=0,
			Bottom=1,
			Left=0,
			Right=1
			},
		["Aura_IconData"]={
			OffsetX=0,
			OffsetY=0,
			Height=20,
			Width=20,
			Red=1,
			Green=1,
			Blue=1,
			Alpha=1,
			Texture="",
			TextureBlend="BLEND",
			Left=0,
			Right=1,
			Top=0,
			Bottom=1,
			RAngle=0,
			DeepCheck=1
			},
		["Aura_BackgroundData"]={
			OffsetX=0,
			OffsetY=0,
			Height=22,
			Width=22,
			Red=1,
			Green=1,
			Blue=1,
			Alpha=1,
			Texture="Interface\\Addons\\NPA\\texture\\blank",
			TextureBlend="BLEND",
			Left=0,
			Right=1,
			Top=0,
			Bottom=1,
			RAngle=0,
			DeepCheck=1
			},
		["Aura_HighlightData"]={
			OffsetX=0,
			OffsetY=0,
			Height=24,
			Width=24,
			Red=1,
			Green=1,
			Blue=1,
			Alpha=0.3,
			Texture="Interface\\Addons\\NPA\\texture\\blank",
			TextureBlend="BLEND",
			Left=0,
			Right=1,
			Top=0,
			Bottom=1,
			RAngle=0,
			DeepCheck=1
			},
		["Aura_OverlayData"]={
			OffsetX=0,
			OffsetY=0,
			Height=22,
			Width=22,
			Red=1,
			Green=1,
			Blue=1,
			Alpha=1,
			Texture="",
			TextureBlend="BLEND",
			Left=0,
			Right=1,
			Top=0,
			Bottom=1,
			RAngle=0,
			DeepCheck=1
			},
		["Aura_TimeData"]={
			Font=GameFontNormal:GetFont(),
			OffsetX=5,
			OffsetY=-5,
			ShadowX=1,
			ShadowY=-1,
			Size=11,
			Mode="OUTLINE",
			Red=1,
			Green=1,
			Blue=1,
			Alpha=1,
			DeepCheck=1
			},
	

		["Aura_StackData"]={
			Font=GameFontNormal:GetFont(),
			OffsetX=-5,
			OffsetY=5,
			ShadowX=1,
			ShadowY=-1,
			Size=11,
			Mode="OUTLINE",
			Red=1,
			Green=1,
			Blue=1,
			Alpha=1,
			DeepCheck=1
			},
	
		["Aura_OffsetX"]=0,
		["Aura_OffsetY"]=15,
		["Aura_BuffOffsetX"]=0,
		["Aura_BuffOffsetY"]=0,
		["Aura_DebuffOffsetX"]=0,
		["Aura_DebuffOffsetY"]=0,
		["Aura_MaxBuff"]=6,
		["Aura_MaxDebuff"]=6,
		["Aura_BuffPerRow"]=6,
		["Aura_DebuffPerRow"]=6,
		["Aura_FrameAnchor"]="CENTER",
		["Aura_BuffFrameAnchor"]="BOTTOM",
		["Aura_DebuffFrameAnchor"]="BOTTOM",
		["Aura_BuffAnchorDebuff"]=0,
		["Aura_DebuffAnchorBuff"]=1,
		["Aura_GapX"]=1,
		["Aura_GapY"]=1,
		["Aura_BuffGrowUpward"]=1,
		["Aura_BuffGrowRightward"]=1,
		["Aura_DebuffGrowUpward"]=1,
		["Aura_DebuffGrowRightward"]=1,
		["Aura_Font"]=GameFontNormal:GetFont(),
		["Aura_Filter_SelfBuff"]=1,
		["Aura_Filter_SelfDebuff"]=1,
		["Aura_Filter_OtherBuff"]=0,
		["Aura_Filter_OtherDebuff"]=0,
		["Aura_Filter_PetBuff"]=0,
		["Aura_Filter_PetDebuff"]=1,
		["Aura_Filter_TargetBuff"]=1,
		["Aura_Filter_TargetDebuff"]=1,
		["Aura_Filter_FocusBuff"]=0,
		["Aura_Filter_FocusDebuff"]=0,
		["Aura_Filter_MouseoverBuff"]=0,
		["Aura_Filter_MouseoverDebuff"]=0,
		["Aura_Filter_BuffTime"]=60,
		["Aura_Filter_DebuffTime"]=60,
		["Aura_Filter_WhiteList_Spellid"]={},
		["Aura_Filter_WhiteList_Spellname"]={},
		["Aura_Filter_BlackList_Spellid"]={},
		["Aura_Filter_BlackList_Spellname"]={},
		["Aura_Filter_Magic"]=1,
		["Aura_Filter_Poison"]=1,
		["Aura_Filter_Curse"]=1,
		["Aura_Filter_Disease"]=1,
		["Aura_Filter_Stealable"]=1,
		["Aura_Filter_Physic"]=1,
		["Aura_Filter_Highlight_Magic"]=0,
		["Aura_Filter_Highlight_Posion"]=0,
		["Aura_Filter_Highlight_Disease"]=0,
		["Aura_Filter_Highlight_Physic"]=0,
		["Aura_Filter_Highlight_Curse"]=0,
		["Aura_Filter_Highlight_Stealable"]=1,
		["Aura_Filter_Highlight_Mine"]=1,
		["Aura_Filter_Highlight_Other"]=0,
		["Aura_Highlight"]=1,
		["Aura_Decile"]=0,
		["Aura_BuffScale"]=1,
		["Aura_DebuffScale"]=1,
		["Aura_UseHighlightScale"]=0,
		["Aura_HighlightScale"]=1,
		["Aura_ScaleList"]={},
		["Aura_HighlightList"]={},
		["Aura_ShowBar"]=1,
		["Aura_Decile"]=0,
		["Aura_ColorHighlight"]=0,
		["Aura_ColorBackground"]=0,
		["Aura_ColorMagic"]=1,
		["Aura_ColorPosion"]=1,
		["Aura_ColorDisease"]=1,
		["Aura_ColorCurse"]=1,
		["Aura_ColorPhysic"]=1,
		["Aura_ColorBar"]=0,
		["Aura_ColorBarByTime"]=0,
		["Aura_ColorTextByTime"]=0,

		["Aura_AlterDecile"]=0,
		["Aura_SortBySpellid"]=0,
		["Aura_SortByTimeleft"]=0,
		["Aura_SortByCaster"]=0,
	}

local NPA_Aura_Config=NPA_Aura_DefaultSetting

function NPA_Aura:ResetConfig()
	NPA_Config["Aura"]=CopyTable(NPA_Aura_DefaultSetting)
end

function NPA_Aura:ClearData()

end


-- get global functions
local pairs = pairs
local floor = floor
local table_insert = table.insert
local table_getn = table.getn
local table_sort = table.sort
local tostring=tostring
local mod = mod
local abs = abs

local SpellData=NPA_Core.SpellData

local function NPA_Aura_SpellFilter(spellid)
	local data=SpellData[spellid]
	--white and black list filter
	if(not data)then
		return false
	end

	local school=data.School
	
	--school filter
	if((NPA_Aura_Config["Aura_Filter_Magic"]==1 and school=="Magic") or
		(NPA_Aura_Config["Aura_Filter_Poison"]==1 and school=="Poison") or
		(NPA_Aura_Config["Aura_Filter_Disease"]==1 and school=="Disease") or
		(NPA_Aura_Config["Aura_Filter_Curse"]==1 and school=="Curse") or
		(NPA_Aura_Config["Aura_Filter_Physic"]==1 and school==nil) or 
		(NPA_Aura_Config["Aura_Filter_Stealable"]==1 and data.Stealable))then
			return data
	end

	return nil
end

local function NPA_Aura_Filter(aura,type,selfguid,guids,nTime)
	--time filter
	local extime=aura.ExpirationTime
	local casterguid=aura.CasterGUID

	if(type=="BUFF")then
		if(extime)then
			local timeleft=extime-nTime
			local timefilter=NPA_Aura_Config["Aura_Filter_BuffTime"]
			if((extime~=0 and timeleft<0)or
				(timefilter>0 and (timeleft>timefilter or extime==0)))then
				return false
			end
		end

		if((casterguid==guids.Pet and NPA_Aura_Config["Aura_Filter_PetBuff"]==1) or
			(casterguid==guids.Focus and NPA_Aura_Config["Aura_Filter_FocusBuff"]==1) or
			(casterguid==guids.Target and NPA_Aura_Config["Aura_Filter_TargetBuff"]==1)or
			(casterguid==guids.Mouseover and NPA_Aura_Config["Aura_Filter_MouseoverBuff"]==1)or
			(casterguid==selfguid and NPA_Aura_Config["Aura_Filter_SelfBuff"]==1) or
			(casterguid~=selfguid and casterguid~=guids.Pet and casterguid~=guids.Focus and 
				casterguid~=guids.Target and casterguid~=guids.Mouseover and NPA_Aura_Config["Aura_Filter_OtherBuff"]==1) )then
			return true
		end

	elseif(type=="DEBUFF")then
		if(extime)then
			local timeleft=extime-nTime
			local timefilter=NPA_Aura_Config["Aura_Filter_DebuffTime"]
			if((extime~=0 and timeleft<0)or
				(timefilter>0 and (timeleft>timefilter or extime==0)))then
				return false
			end
		end

		if((casterguid==guids.Pet and NPA_Aura_Config["Aura_Filter_PetDebuff"]==1) or
			(casterguid==guids.Focus and NPA_Aura_Config["Aura_Filter_FocusDebuff"]==1) or
			(casterguid==guids.Target and NPA_Aura_Config["Aura_Filter_TargetDebuff"]==1)or
			(casterguid==guids.Mouseover and NPA_Aura_Config["Aura_Filter_MouseoverDebuff"]==1)or 
			(casterguid==selfguid and NPA_Aura_Config["Aura_Filter_SelfDebuff"]==1) or
			(casterguid~=selfguid and casterguid~=guids.Pet and casterguid~=guids.Focus and casterguid~=guids.Target 
				and casterguid~=guids.Mouseover and NPA_Aura_Config["Aura_Filter_OtherDebuff"]==1) )then
			return true
		end
	
	end
	return false
end


local NPA_ManageBar=NPA_Core.ManageBar

local NPA_Aura_SchoolToColor={		
	["Magic"]={r=0,g=0,b=1},
	["Poison"]={r=0,g=1,b=0},
	["Curse"]={r=1,g=0,b=1},
	["Disease"]={r=0.6,g=0.6,b=0},
	["Physic"]={r=1,g=1,b=0}
}

local function NPA_Aura_SetIconDisplay(main,data,aura,nTime,selfguid,highlight,scale,highlightscale,highlightlist,maxduration,showbar)
	--Frame,Icon,Text,Count
	--icon
	main.Icon:SetTexture(data.Icon)

	--school filter
	local school=data.School
	local color
	if((NPA_Aura_Config["Aura_ColorMagic"]==1 and school=="Magic") or
		(NPA_Aura_Config["Aura_ColorPosion"]==1 and school=="Posion") or
		(NPA_Aura_Config["Aura_ColorCurse"]==1 and school=="Curse") or
		(NPA_Aura_Config["Aura_ColorDisease"]==1 and school=="Disease") or
		(NPA_Aura_Config["Aura_ColorPhysic"]==1 and school==nil))then

		color=NPA_Aura_SchoolToColor[(school or "Physic")] or {r=1,g=1,b=1}
	else
		color={r=1,g=1,b=1}
	end

	if(NPA_Aura_Config["Aura_ColorBackground"]==1)then
		local bg=main.Background
		bg:SetVertexColor(bg.R*color.r,bg.G*color.g,bg.B*color.b)
	else
		local bg=main.Background
		bg:SetVertexColor(bg.R,bg.G,bg.B)
	end

	if(NPA_Aura_Config["Aura_ColorBar"]==1)then
		local bar=main.Bar
		bar:SetVertexColor(bar.R*color.r,bar.G*color.g,bar.B*color.b)
	else
		local bar=main.Bar
		bar:SetVertexColor(bar.R,bar.G,bar.B)
	end
	

	local s

	--highlight
	if(highlight==1)then
		local casterguid=aura.CasterGUID

		if((NPA_Aura_Config["Aura_Filter_Highlight_Magic"]==1 and school=="Magic") or
		(NPA_Aura_Config["Aura_Filter_Highlight_Poison"]==1 and school=="Poison") or
		(NPA_Aura_Config["Aura_Filter_Highlight_Curse"]==1 and school=="Curse") or
		(NPA_Aura_Config["Aura_Filter_Highlight_Disease"]==1 and school=="Disease") or
		(NPA_Aura_Config["Aura_Filter_Highlight_Physic"]==1 and school==nil) or 
		(NPA_Aura_Config["Aura_Filter_Highlight_Stealable"]==1 and data.Stealable) or 
		(NPA_Aura_Config["Aura_Filter_Highlight_Mine"]==1 and casterguid==selfguid) or
		(NPA_Aura_Config["Aura_Filter_Highlight_Other"]==1 and casterguid~=selfguid) or
		(highlightlist))then

			local hl=main.Highlight
			hl:Show()
			s=highlightscale or scale or 1

			if(NPA_Aura_Config["Aura_ColorHighlight"]==1)then
				hl:SetVertexColor(hl.R*color.r,hl.G*color.g,hl.B*color.b)
			else
				hl:SetVertexColor(hl.R,hl.G,hl.B)
			end

		else
			s=scale or 1
			main.Highlight:Hide()
		end
	else
		s=scale or 1
		main.Highlight:Hide()
	end

	--timeleft
	local extime=aura.ExpirationTime
	if(extime and extime~=0) then
		local timeleft=extime-nTime
		local timetext
		if(timeleft<2 and NPA_Aura_Config["Aura_Decile"]==1)then
			if(NPA_Aura_Config["Aura_AlterDecile"]~=1)then
				timetext=floor(timeleft*10)/10
			elseif(timeleft<1)then
				timetext="."..floor(timeleft*10)
			else
				timetext=floor(timeleft)
			end
		elseif(timeleft<100)then
			timetext=floor(timeleft)
		else
			timetext="*"
		end
		
		if(NPA_Aura_Config["Aura_ColorTextByTime"]==1)then
			if(timeleft>100)then
				timetext="|cff00ff00"..timetext
			elseif(timeleft>20)then
				timetext="|cffffff00"..timetext
			else
				timetext="|cffff0000"..timetext
			end
		end
		main.Text:SetText(timetext)

		--bar
		if(showbar==1)then
			local guid=aura.CasterGUID or 0
			if(maxduration and maxduration[guid] and maxduration[guid]>0)then
				local bar=main.Bar
				bar.Percent=timeleft/maxduration[guid]
				NPA_ManageBar(nil,bar)

				if(NPA_Aura_Config["Aura_ColorBarByTime"]==1)then
					local percent=bar.Percent
					bar:SetVertexColor(bar.R*(1-percent),bar.G*percent,0)
				end
			else
				main.Bar:Hide()
			end
		else
			main.Bar:Hide()
		end
	else
		main.Text:SetText(nil)
	end


	--count
	local stack=aura.Count
	if(stack and stack>1) then
		main.Stack:SetText(stack)
	else
		main.Stack:SetText(nil)
	end

	main.Scale=s
	main:SetScale(s)
	main:Show()
end

local function NPA_Aura_SetAuraDisplay(main,count,max,row,width,height,gapx,gapy)
	count=count-1
	if(count<1)then
		main:SetWidth(1)
		main:SetHeight(1)
		main:Hide()
		return 0
	elseif(count>max)then
		count=max
	end

	local zheight=height+gapy
	local zwidth=width+gapx

	local bwidth=zwidth*main.Icon[1].Scale
	local bheight=zheight*main.Icon[1].Scale

	local brow=bwidth
	local bcol=0

	local lastheight=bheight

	local icons=main.Icon

	for i=2,count do
		local icon=icons[i]
		if(mod(i,row)==1)then
			bcol=bcol+bheight
			if(bwidth>brow)then
				brow=bwidth
			end
			bwidth=zwidth*icon.Scale

			icon:SetPoint(icon.Anchor,icons[icon.AnchorId],icon.Anchor,0,bheight/icon.Scale*icon.Dir)

			bheight=zheight*icon.Scale
		else
			bwidth=bwidth+zwidth*icon.Scale
			local h=zheight*icon.Scale
			if(h>bheight)then
				bheight=h
			end
		end
	end

	if(count<=row)then
		brow=bwidth
	end
	bcol=bcol+bheight

	main:SetWidth(brow)
	main:SetHeight(bcol)
	main:Show()

	return 1
end

local function NPA_Aura_SortBySpellid(a,b)
	return (a.spellid or 1)>(b.spellid or 0)
end

local function NPA_Aura_SortByTimeleft(a,b)
	return (a.aura.ExpirationTime or 1)>(b.aura.ExpirationTime or 0)
end
local function NPA_Aura_SortByCaster(a,b)
	return (a.aura.CasterGUID or 1)>(b.aura.CasterGUID or 0)
end


local function NPA_Aura_OnUpdate(nTime,self,guid,unitdata,selfguid,guids)
	local bufficons=self.BuffMain.Icon
	local debufficons=self.DebuffMain.Icon

	local buffcount=1
	local debuffcount=1
	local buffmax=NPA_Aura_Config["Aura_MaxBuff"]
	local debuffmax=NPA_Aura_Config["Aura_MaxDebuff"]
	--sort buff&debuff
	local whitelistname=NPA_Aura_Config["Aura_Filter_WhiteList_Spellname"]
	local whitelistid=NPA_Aura_Config["Aura_Filter_WhiteList_Spellid"]
	local blacklistname=NPA_Aura_Config["Aura_Filter_BlackList_Spellname"]
	local blacklistid=NPA_Aura_Config["Aura_Filter_BlackList_Spellid"]


	local bufflist={}
	local debufflist={}
	local maxdurationcache=NPA_Core.Aura_Duration_Cache

	for spellid,auras in pairs(unitdata.Aura) do
		if(table_getn(auras)>0)then
			local data=NPA_Aura_SpellFilter(spellid)
			local maxduration=maxdurationcache[spellid]
			if(data)then
				local name=data.Name or ""
				local id=tostring(spellid) or ""

				if(whitelistname[name]==1 or whitelistid[id]==1)then
					for _,aura in pairs(auras) do
						if(data.Type=="DEBUFF" and debuffcount<=debuffmax) then
							table_insert(debufflist,{
								data=data,
								aura=aura,
								spellid=spellid,
								maxduration=maxduration
								})

							debuffcount=debuffcount+1
						elseif(data.Type=="BUFF" and buffcount<=buffmax)then
							table_insert(bufflist,{
								data=data,
								aura=aura,
								spellid=spellid,
								maxduration=maxduration
								})
							buffcount=buffcount+1
						end
					end
				elseif(blacklistname[name]~=1 and blacklistid[id]~=1)then
					for _,aura in pairs(auras) do
						if(NPA_Aura_Filter(aura,data.Type,selfguid,guids,nTime))then --apply filter
							if(data.Type=="DEBUFF" and debuffcount<=debuffmax) then
								table_insert(debufflist,{
									data=data,
									aura=aura,
									spellid=spellid,
									maxduration=maxduration
									})
								debuffcount=debuffcount+1
							elseif(data.Type=="BUFF" and buffcount<=buffmax)then
								table_insert(bufflist,{
									data=data,
									aura=aura,
									spellid=spellid,
									maxduration=maxduration
									})
								buffcount=buffcount+1
							end
						end
					end
				end
			end
		end
	end

	local highlight=NPA_Aura_Config["Aura_Highlight"]

	local highlightscale
	if(NPA_Aura_Config["Aura_UseHighlightScale"]==1)then
		highlightscale=NPA_Aura_Config["Aura_HighlightScale"]
	end

	local scalelist=NPA_Aura_Config["Aura_ScaleList"]
	local highlightlist=NPA_Aura_Config["Aura_HighlightList"]
	local showbar=NPA_Aura_Config["Aura_ShowBar"]


	if(NPA_Aura_Config["Aura_SortBySpellid"]==1)then
		table_sort(bufflist,NPA_Aura_SortBySpellid)
		table_sort(debufflist,NPA_Aura_SortBySpellid)
	elseif(NPA_Aura_Config["Aura_SortByTimeleft"]==1)then
		table_sort(bufflist,NPA_Aura_SortByTimeleft)
		table_sort(debufflist,NPA_Aura_SortByTimeleft)
--	elseif(NPA_Aura_Config["Aura_SortByCaster"]==1)then
--		table_sort(bufflist,NPA_Aura_SortByCaster)
--		table_sort(debufflist,NPA_Aura_SortByCaster)
	end

	for i=1,buffcount-1 do
		local aura=bufflist[i]
		local icon=bufficons[i]
--					main,     data,       aura,   nTime,selfguid,highlight,scale,                  highlightscale,highlightlist,              maxduration,     showbar)
		NPA_Aura_SetIconDisplay(icon,aura.data,aura.aura,nTime,selfguid,highlight,scalelist[aura.spellid],highlightscale,highlightlist[aura.spellid],aura.maxduration,showbar)
	end

	for i=1,debuffcount-1 do
		local aura=debufflist[i]
		local icon=debufficons[i]
		NPA_Aura_SetIconDisplay(icon,aura.data,aura.aura,nTime,selfguid,highlight,scalelist[aura.spellid],highlightscale,highlightlist[aura.spellid],aura.maxduration,showbar)
	end


	local bwidth=0
	local bheight=0

	local gapx=self.GapX
	local gapy=self.GapY
	local width=self.Width
	local height=self.Height

	for i=buffcount,NPA_Aura_Config["Aura_MaxBuff"] do 
		bufficons[i]:Hide()
	end
	for i=debuffcount,NPA_Aura_Config["Aura_MaxDebuff"] do
		debufficons[i]:Hide()
	end
	
	--aura displays
	
	local a1=NPA_Aura_SetAuraDisplay(self.BuffMain,buffcount,buffmax,NPA_Aura_Config["Aura_BuffPerRow"],width,height,gapx,gapy)
	local a2=NPA_Aura_SetAuraDisplay(self.DebuffMain,debuffcount,debuffmax,NPA_Aura_Config["Aura_DebuffPerRow"],width,height,gapx,gapy)
	if(a1==0 and a2==0)then
		self:Hide()
	else
		self:Show()
	end
end

local function NPA_Aura_CreateIcon(main)
	local frame=CreateFrame("Frame","NPA_Aura_IconFrame",main)
	frame:Hide()
		
	frame.Icon=frame:CreateTexture(nil,"BORDER",nil)
	frame.Icon:Show()
		
	frame.Background=frame:CreateTexture(nil,"BACKGROUND",nil)
	frame.Background:Show()

	frame.Text=frame:CreateFontString(nil,"OVERLAY",nil)
	frame.Text:Show()
		
	frame.Stack=frame:CreateFontString(nil,"OVERLAY",nil)
	frame.Stack:Show()

	frame.Overlay=frame:CreateTexture(nil,"OVERLAY",nil)
	frame.Overlay:Show()

	frame.Highlight=frame:CreateTexture(nil,"OVERLAY",nil)
	frame.Highlight:Hide()

	frame.Bar=frame:CreateTexture(nil,"ARTWORK",nil)
	frame.Bar:Hide()
	
	return frame
end



local function NPA_Aura_CreateBuffFrame(mainframe,num)
	local data={}
	for  i=1 ,num do
		data[i]=NPA_Aura_CreateIcon(mainframe)
	end
	return data
end

local ManageTexture=NPA_Core.TextureManager2
local ManageFont=NPA_Core.FontManager

local function NPA_Aura_SetBuffFrame(list,i,main,row,width,height,gapx,gapy,growup,growright)
	local frame=list[i]

	frame:ClearAllPoints()

	local index=i

	if(index==1)then
		local anchor
		if(growup~=1)then
			anchor="TOP"
		else
			anchor="BOTTOM"
		end
		if(growright~=1)then
			anchor=anchor.."RIGHT"
		else
			anchor=anchor.."LEFT"
		end
		frame:SetPoint(anchor,main,anchor,0,0)
	elseif(mod(index,row)==1 or row==1)then
		local anchor
		local anchorb
		if(growup~=1)then
			gapy=-gapy
			anchor="TOP"
			anchorb="BOTTOM"
		else
			anchor="BOTTOM"
			anchorb="TOP"
		end
		gapx=0
		if(growright~=1)then
			anchor=anchor.."RIGHT"
			anchorb=anchorb.."RIGHT"
		else
			anchor=anchor.."LEFT"
			anchorb=anchorb.."LEFT"
		end
		local id
		if(row==1)then
			id=index-1
		else
			id=((floor(index/row)-1)*row+1)
		end
		frame.AnchorId=id
		frame.Anchor=anchor
		frame.Dir=gapy/abs(gapy)
		frame:SetPoint(anchor,list[id],anchorb,gapx,gapy)
	else
		gapy=0
		if(growup~=1)then
			anchor="TOP"
			anchorb="TOP"
		else
			anchor="BOTTOM"
			anchorb="BOTTOM"
		end
		if(growright~=1)then
			gapx=-gapx
			anchor=anchor.."RIGHT"
			anchorb=anchorb.."LEFT"
		else
			anchor=anchor.."LEFT"
			anchorb=anchorb.."RIGHT"
		end
		frame:SetPoint(anchor,list[(index-1)],anchorb,gapx,gapy)
	end

	frame:SetHeight(height)
	frame:SetWidth(width)

	ManageTexture(nil,frame.Icon,NPA_Aura_Config["Aura_IconData"],"CENTER",frame,"CENTER")
	
	ManageTexture(nil,frame.Background,NPA_Aura_Config["Aura_BackgroundData"],"CENTER",frame,"CENTER")

	ManageTexture(nil,frame.Overlay,NPA_Aura_Config["Aura_OverlayData"],"CENTER",frame,"CENTER")

	ManageTexture(nil,frame.Highlight,NPA_Aura_Config["Aura_HighlightData"],"CENTER",frame,"CENTER")
	frame.Highlight:Hide()

	ManageTexture(nil,frame.Bar,NPA_Aura_Config["Aura_BarData"],"CENTER",frame,"CENTER",1)
	frame.Bar:Hide()


	ManageFont(nil,frame.Text,NPA_Aura_Config["Aura_TimeData"],"CENTER",frame,"CENTER")

	ManageFont(nil,frame.Stack,NPA_Aura_Config["Aura_StackData"],"CENTER",frame,"CENTER")
	
end

local function NPA_Aura_GetInversAnchor(anchor)
	if(anchor=="LEFT")then
		return "RIGHT"
	elseif(anchor=="RIGHT")then
		reruen "LEFT"
	elseif(anchor=="TOPLEFT")then
		return "BOTTOMRIGHT"
	elseif(anchor=="TOPRIGHT")then
		return "BOTTOMLEFT"
	elseif(anchor=="TOP")then
		return "BOTTOM"
	elseif(anchor=="BOTTOM")then
		return "TOP"
	elseif(anchor=="BOTTOMLEFT")then
		return "TOPRIGHT"
	elseif(anchor=="BOTTOMRIGHT")then
		return "TOPLEFT"
	end
end

local function NPA_Aura_SetFrame(auraframe)
	auraframe:ClearAllPoints()
	auraframe:SetPoint(NPA_Aura_Config["Aura_FrameAnchor"],auraframe:GetParent(),"CENTER",NPA_Aura_Config["Aura_OffsetX"],NPA_Aura_Config["Aura_OffsetY"])

	auraframe.BuffMain:ClearAllPoints()
	auraframe.DebuffMain:ClearAllPoints()
	local anchor=NPA_Aura_Config["Aura_BuffFrameAnchor"]
	if(NPA_Aura_Config["Aura_BuffAnchorDebuff"]==1)then
		auraframe.BuffMain:SetPoint(anchor,auraframe.DebuffMain,NPA_Aura_GetInversAnchor(anchor),NPA_Aura_Config["Aura_BuffOffsetX"],NPA_Aura_Config["Aura_BuffOffsetY"])
	else
		auraframe.BuffMain:SetPoint(anchor,auraframe,NPA_Aura_GetInversAnchor(anchor),NPA_Aura_Config["Aura_BuffOffsetX"],NPA_Aura_Config["Aura_BuffOffsetY"])
	end

	anchor=NPA_Aura_Config["Aura_DebuffFrameAnchor"]
	if(NPA_Aura_Config["Aura_DebuffAnchorBuff"]==1 and NPA_Aura_Config["Aura_BuffAnchorDebuff"]~=1)then
		auraframe.DebuffMain:SetPoint(anchor,auraframe.BuffMain,NPA_Aura_GetInversAnchor(anchor),NPA_Aura_Config["Aura_DebuffOffsetX"],NPA_Aura_Config["Aura_DebuffOffsetY"])
	else
		auraframe.DebuffMain:SetPoint(anchor,auraframe,NPA_Aura_GetInversAnchor(anchor),NPA_Aura_Config["Aura_DebuffOffsetX"],NPA_Aura_Config["Aura_DebuffOffsetY"])
	end

	auraframe.BuffMain:SetScale(NPA_Aura_Config["Aura_BuffScale"])
	auraframe.DebuffMain:SetScale(NPA_Aura_Config["Aura_DebuffScale"])

	local height=NPA_Aura_Config["Aura_IconData"].Height
	local width=NPA_Aura_Config["Aura_IconData"].Width

	local gapy=NPA_Aura_Config["Aura_GapY"]
	local gapx=NPA_Aura_Config["Aura_GapX"]

	auraframe.GapX=gapx
	auraframe.GapY=gapy
	auraframe.Height=height
	auraframe.Width=width

	for i=1,NPA_Aura_Config["Aura_MaxDebuff"] do
		if(not auraframe.DebuffMain.Icon[i])then
			auraframe.DebuffMain.Icon[i]=NPA_Aura_CreateIcon(auraframe.DebuffMain)
		end
		NPA_Aura_SetBuffFrame(auraframe.DebuffMain.Icon,i,auraframe.DebuffMain,NPA_Aura_Config["Aura_DebuffPerRow"],width,height,gapx,gapy,NPA_Aura_Config["Aura_DebuffGrowUpward"],NPA_Aura_Config["Aura_DebuffGrowRightward"])
	end

	for i=1,table_getn(auraframe.DebuffMain.Icon) do
		auraframe.DebuffMain.Icon[i]:Hide()
	end
	for i=1,NPA_Aura_Config["Aura_MaxBuff"] do
		if(not auraframe.BuffMain.Icon[i])then
			auraframe.BuffMain.Icon[i]=NPA_Aura_CreateIcon(auraframe.BuffMain)
		end

		NPA_Aura_SetBuffFrame(auraframe.BuffMain.Icon,i,auraframe.BuffMain,NPA_Aura_Config["Aura_BuffPerRow"],width,height,gapx,gapy,NPA_Aura_Config["Aura_BuffGrowUpward"],NPA_Aura_Config["Aura_BuffGrowRightward"])
	end


	for i=1,table_getn(auraframe.BuffMain.Icon) do
		auraframe.BuffMain.Icon[i]:Hide()
	end

end

local function NPA_Aura_HookFrame(frame)
	local main=CreateFrame("Frame","NPA_Aura_MainFrame",frame)
	main:SetWidth(1)
	main:SetHeight(1)
	main:Hide()

	main.BuffMain=CreateFrame("Frame","NPA_Aura_BuffMainFrame",main)

	main.DebuffMain=CreateFrame("Frame","NPA_Aura_DebuffMainFrame",main)

	
	main.BuffMain.Icon=NPA_Aura_CreateBuffFrame(main.BuffMain,NPA_Aura_Config["Aura_MaxBuff"])
	main.DebuffMain.Icon=NPA_Aura_CreateBuffFrame(main.DebuffMain,NPA_Aura_Config["Aura_MaxDebuff"])

	table_insert(NPA_Aura_Frame,main)
	NPA_Aura_SetFrame(main)

	frame["Aura"]=main
end


function NPA_Aura:ApplyConfig()
	NPA_Core:CheckConfigEntry("Aura",NPA_Aura_DefaultSetting)

	NPA_Aura_Config=NPA_Config["Aura"]

	for _,auraframe in pairs(NPA_Aura_Frame) do
		NPA_Aura_SetFrame(auraframe)
	end
end

--onload functions
NPA_Core:AddHook("Aura",NPA_Aura_HookFrame)
NPA_Core:AddModule("Aura",NPA_Aura)
NPA_Core:HookUpdate("Aura",NPA_Aura_OnUpdate,2)
