﻿-- Author      : Nogarder
-- Create Date : 2010/7/5 2:09:16

local Localization={}
if(locale=="zhTW")then
	Localization={
		["Unknow"]="Unknow",
	}
elseif(locale=="zhCN")then
	Localization={
		["Unknow"]="Unknow",
	}
else
	Localization={
		["Unknow"]="Unknow",
	}
end

--global functions

local pairs=pairs
local strfind=strfind
local GetSpellInfo=GetSpellInfo
local GetTime=GetTime
local unpack=unpack
local random=random
local abs=abs

local table_insert=table.insert

local GetTime=GetTime

local COMBATLOG_OBJECT_REACTION_HOSTILE=COMBATLOG_OBJECT_REACTION_HOSTILE
local bit_band=bit.band


local GUIDToFrame=NPA_Core.GUIDToFrame

--config
local NPA_ScrollText={}

local NPA_ScrollText_DefaultSetting={
		["ScrollText_UpdateInterval"]=0.03,

		["ScrollText_FlyingIconData"]={
			OffsetX=0,
			OffsetY=0,
			Height=20,
			Width=20,
			Red=1,
			Green=1,
			Blue=1,
			Alpha=1,
			Texture="",
			TextureBlend="BLEND",
			Left=0,
			Right=1,
			Top=0,
			Bottom=1,
			RAngle=0,
			DeepCheck=1
			},
		["ScrollText_FlyingBackgroundData"]={
			OffsetX=0,
			OffsetY=0,
			Height=22,
			Width=22,
			Red=1,
			Green=1,
			Blue=1,
			Alpha=1,
			Texture="",
			TextureBlend="BLEND",
			Left=0,
			Right=1,
			Top=0,
			Bottom=1,
			RAngle=0,
			DeepCheck=1
			},
		["ScrollText_FlyingOverlayData"]={
			OffsetX=0,
			OffsetY=0,
			Height=22,
			Width=22,
			Red=1,
			Green=1,
			Blue=1,
			Alpha=1,
			Texture="",
			TextureBlend="BLEND",
			Left=0,
			Right=1,
			Top=0,
			Bottom=1,
			RAngle=0,
			DeepCheck=1
			},


		["ScrollText_IconData"]={
			OffsetX=0,
			OffsetY=0,
			Height=25,
			Width=25,
			Red=1,
			Green=1,
			Blue=1,
			Alpha=1,
			Texture="",
			TextureBlend="BLEND",
			Left=0,
			Right=1,
			Top=0,
			Bottom=1,
			RAngle=0,
			DeepCheck=1
			},
		["ScrollText_BackgroundData"]={
			OffsetX=0,
			OffsetY=0,
			Height=22,
			Width=22,
			Red=1,
			Green=1,
			Blue=1,
			Alpha=1,
			Texture="",
			TextureBlend="BLEND",
			Left=0,
			Right=1,
			Top=0,
			Bottom=1,
			RAngle=0,
			DeepCheck=1
			},
		["ScrollText_OverlayData"]={
			OffsetX=0,
			OffsetY=0,
			Height=22,
			Width=22,
			Red=1,
			Green=1,
			Blue=1,
			Alpha=1,
			Texture="",
			TextureBlend="BLEND",
			Left=0,
			Right=1,
			Top=0,
			Bottom=1,
			RAngle=0,
			DeepCheck=1
			},
		["ScrollText_CritIconData"]={
			OffsetX=0,
			OffsetY=0,
			Height=40,
			Width=40,
			Red=1,
			Green=1,
			Blue=1,
			Alpha=1,
			Texture="",
			TextureBlend="BLEND",
			Left=0,
			Right=1,
			Top=0,
			Bottom=1,
			RAngle=0,
			DeepCheck=1
			},
		["ScrollText_CritBackgroundData"]={
			OffsetX=0,
			OffsetY=0,
			Height=22,
			Width=22,
			Red=1,
			Green=1,
			Blue=1,
			Alpha=1,
			Texture="",
			TextureBlend="BLEND",
			Left=0,
			Right=1,
			Top=0,
			Bottom=1,
			RAngle=0,
			DeepCheck=1
			},
		["ScrollText_CritOverlayData"]={
			OffsetX=0,
			OffsetY=0,
			Height=22,
			Width=22,
			Red=1,
			Green=1,
			Blue=1,
			Alpha=1,
			Texture="",
			TextureBlend="BLEND",
			Left=0,
			Right=1,
			Top=0,
			Bottom=1,
			RAngle=0,
			DeepCheck=1
			},

		["ScrollText_TextData"]={
			Font=GameFontNormal:GetFont(),
			OffsetX=0,
			OffsetY=0,
			ShadowX=1,
			ShadowY=-1,
			Size=20,
			Mode="OUTLINE",
			Red=1,
			Green=1,
			Blue=1,
			Alpha=1,
			DeepCheck=1
			},
	
		["ScrollText_CritTextData"]={
			Font=GameFontNormal:GetFont(),
			OffsetX=0,
			OffsetY=0,
			ShadowX=1,
			ShadowY=-1,
			Size=40,
			Mode="OUTLINE",
			Red=1,
			Green=1,
			Blue=1,
			Alpha=1,
			DeepCheck=1
			},

		["ScrollText_OffsetX"]=0,
		["ScrollText_OffsetY"]=20,
		["ScrollText_SpeedX"]=0,
		["ScrollText_SpeedY"]=150,
		["ScrollText_Max"]=50,
		["ScrollText_SpreadX"]=100,
		["ScrollText_SpreadY"]=50,
		["ScrollText_AccX"]=0,
		["ScrollText_AccY"]=-200,
		["ScrollText_Life"]=1.5,
		["ScrollText_Filter_Melee"]=1,
		["ScrollText_Filter_Range"]=1,
		["ScrollText_Filter_Spell"]=1,
		["ScrollText_Filter_Miss"]=1,
		["ScrollText_Filter_Aura"]=0,
		["ScrollText_Filter_Heal"]=1,
		["ScrollText_Filter_Dot"]=1,
		["ScrollText_Filter_Interrupt"]=1,
		["ScrollText_Filter_ShowCaster"]=0,
		["ScrollText_Filter_ShowSelf"]=0,
		["ScrollText_Filter_ShowSpellName"]=0,
		["ScrollText_Filter_ShowMySelf"]=1,
		["ScrollText_Filter_ShowOnSelf"]=1,
		["ScrollText_Filter_ShowOther"]=1,
		["ScrollText_Filter_ShowSpellRank"]=0,
		["ScrollText_Filter_ShowHostile"]=1,
		["ScrollText_Filter_ShowNonHostile"]=1,
		["ScrollText_Filter_ShowFocus"]=0,
		["ScrollText_Filter_ShowToFocus"]=1,
		["ScrollText_Filter_ShowTarget"]=1,
		["ScrollText_Filter_ShowToTarget"]=1,
		["ScrollText_Filter_StickCrit"]=1,
		["ScrollText_Filter_ShakeCrit"]=1,
		["ScrollText_Filter_Absorb"]=1,
		["ScrollText_Filter_Energized"]=1,
		["ScrollText_HideByFrame"]=0,
		["ScrollText_AlphaByFrame"]=0,
		["ScrollText_FlyingIcon"]=0,
		["ScrollText_HideFullOverHeal"]=0,
	}

local NPA_ScrollText_Config=NPA_ScrollText_DefaultSetting

function NPA_ScrollText:ResetConfig()
	NPA_Config["ScrollText"]=CopyTable(NPA_ScrollText_DefaultSetting)
end


------build filter

local NPA_ScrollText_CombatLogFilter={}
local NPA_ScrollText_OnEventFilterDest={}
local NPA_ScrollText_OnEventFilterFrom={}

local NPA_ScrollText_FlyingIconFilter={}

local function NPA_ScrollText_BuildFilter()
	NPA_ScrollText_CombatLogFilter={}

	if(NPA_ScrollText_Config["ScrollText_Filter_Melee"]==1)then
		NPA_ScrollText_CombatLogFilter["SWING_DAMAGE"]=1
	end

	if(NPA_ScrollText_Config["ScrollText_Filter_Range"]==1)then
		NPA_ScrollText_CombatLogFilter["RANGE_DAMAGE"]=2
	end

	if(NPA_ScrollText_Config["ScrollText_Filter_Spell"]==1)then
		NPA_ScrollText_CombatLogFilter["DAMAGE_SHIELD"]=2
		NPA_ScrollText_CombatLogFilter["DAMAGE_SPLIT"]=2
		NPA_ScrollText_CombatLogFilter["SPELL_DAMAGE"]=2
		NPA_ScrollText_CombatLogFilter["ENVIRONMENTAL_DAMAGE"]=1		
	end
	
	if(NPA_ScrollText_Config["ScrollText_Filter_Dot"]==1)then
		NPA_ScrollText_CombatLogFilter["SPELL_PERIODIC_DAMAGE"]=2
	end
	

	if(NPA_ScrollText_Config["ScrollText_Filter_Miss"]==1)then
		NPA_ScrollText_CombatLogFilter["SWING_MISSED"]=1
		NPA_ScrollText_CombatLogFilter["RANGE_MISSED"]=2
		NPA_ScrollText_CombatLogFilter["SPELL_MISSED"]=2
		NPA_ScrollText_CombatLogFilter["DAMAGE_SHIELD_MISSED"]=2
		NPA_ScrollText_CombatLogFilter["SPELL_DISPEL_FAILED"]=2
	end
	
	
	if(NPA_ScrollText_Config["ScrollText_Filter_Interrupt"]==1)then
		NPA_ScrollText_CombatLogFilter["SPELL_INTERRUPT"]=6
		NPA_ScrollText_CombatLogFilter["SPELL_DISPEL"]=6
		NPA_ScrollText_CombatLogFilter["SPELL_STOLEN"]=6
		NPA_ScrollText_CombatLogFilter["SPELL_AURA_BROKEN"]=8
		NPA_ScrollText_CombatLogFilter["SPELL_AURA_BROKEN_SPELL"]=8
	end
	
	if(NPA_ScrollText_Config["ScrollText_Filter_Aura"]==1)then
		NPA_ScrollText_CombatLogFilter["SPELL_AURA_APPLIED"]=3
		NPA_ScrollText_CombatLogFilter["SPELL_AURA_APPLIED_DOSE"]=3
		--NPA_ScrollText_CombatLogFilter["SPELL_AURA_REFRESH"]=3
		NPA_ScrollText_CombatLogFilter["SPELL_AURA_REMOVED"]=4
		NPA_ScrollText_CombatLogFilter["SPELL_AURA_REMOVED_DOSE"]=4
	end
	if(NPA_ScrollText_Config["ScrollText_Filter_Heal"]==1)then
		NPA_ScrollText_CombatLogFilter["SPELL_HEAL"]=5
		NPA_ScrollText_CombatLogFilter["SPELL_PERIODIC_HEAL"]=5
	end

	if(NPA_ScrollText_Config["ScrollText_Filter_Energized"]==1)then
		NPA_ScrollText_CombatLogFilter["SPELL_ENERGIZE"]=7
		NPA_ScrollText_CombatLogFilter["SPELL_PERIODIC_ENERGIZE"]=7
	end


	if(NPA_ScrollText_Config["ScrollText_FlyingIcon"]==1)then
		NPA_ScrollText_FlyingIconFilter["SPELL_CAST_SUCCESS"]=1
	end

	---on event filters
	--dest filter
	NPA_ScrollText_OnEventFilterDest={}
	if(NPA_ScrollText_Config["ScrollText_Filter_ShowHostile"]==1)then
		NPA_ScrollText_OnEventFilterDest["ShowHostile"]=function(desthostile)
			if(desthostile>0)then
				return 1
			end
		end
	end

	if(NPA_ScrollText_Config["ScrollText_Filter_ShowNonHostile"]==1)then
		NPA_ScrollText_OnEventFilterDest["ShowNonHostile"]=function(desthostile)
			if(desthostile<=0)then
				return 1
			end
		end
	end

	if(NPA_ScrollText_Config["ScrollText_Filter_ShowToFocus"]==1)then
		NPA_ScrollText_OnEventFilterDest["ShowToFocus"]=function(_,destGUID,_,focusguid)
			if(destGUID ==focusguid)then
				return 1
			end
		end
	end

	if(NPA_ScrollText_Config["ScrollText_Filter_ShowToTarget"]==1)then
		NPA_ScrollText_OnEventFilterDest["ShowToTarget"]=function(_,destGUID,targetguid)
			if(destGUID ==targetguid)then
				return 1
			end
		end
	end
	--from filter
	NPA_ScrollText_OnEventFilterFrom={}
	if(NPA_ScrollText_Config["ScrollText_Filter_ShowMySelf"]==1)then
		NPA_ScrollText_OnEventFilterFrom["ShowMySelf"]=function(sourceGUID,myguid,petguid)
			if(sourceGUID ==myguid or sourceGUID==petguid)then
				return 1
			end
		end
	end

	if(NPA_ScrollText_Config["ScrollText_Filter_ShowFocus"]==1)then
		NPA_ScrollText_OnEventFilterFrom["ShowFocus"]=function(sourceGUID,_,_,focusguid)
			if(sourceGUID ==focusguid)then
				return 1
			end
		end
	end

	if(NPA_ScrollText_Config["ScrollText_Filter_ShowTarget"]==1)then
		NPA_ScrollText_OnEventFilterFrom["ShowTarget"]=function(sourceGUID,_,_,_,targetguid)
			if(sourceGUID ==targetguid)then
				return 1
			end
		end
	end

	if(NPA_ScrollText_Config["ScrollText_Filter_ShowOther"]==1)then
		NPA_ScrollText_OnEventFilterFrom["ShowOther"]=function(sourceGUID,myguid,petguid)
			if(sourceGUID~=myguid and sourceGUID~=petguid)then
				return 1
			end
		end
	end

end


local NPA_ScrollText_Scrolls={}
local NPA_ScrollText_Icons={}
local NPA_ScrollText_ScrollCount=1
local NPA_ScrollText_IconCount=1

--spelltype color data /r,g,b
local NPA_ScrollText_SpellTypeColor={
	[1]={r=1,g=1,b=0},
	[2]={r=1,g=1,b=0.5},
	[4]={r=1,g=0.3,b=0},
	[8]={r=0.25,g=1,b=0.25},
	[16]={r=0.5,g=1,b=1},
	[32]={r=0.5,g=0.5,b=1},
	[64]={r=1,g=0.5,b=1}
}
local abs=abs
	
local function NPA_ScrollText_ScrollOnUpdate(self,elapsed)
	self.TimeStack=self.TimeStack+elapsed
	if(self.TimeStack<NPA_ScrollText_Config["ScrollText_UpdateInterval"])then
		return
	end

	local nTime=GetTime()
	local frame=GUIDToFrame[self.GUID]
	local show
	if(frame and frame:IsShown())then
		show=1
	end
	if(self.Life > 0 and (show or NPA_ScrollText_Config["ScrollText_HideByFrame"]~=1))then
		local modalpha=1
		local scale=UIParent:GetScale()
		if(show)then
			local ox,oy=frame:GetCenter()
			if(frame.IsTracker)then
				self.OffsetX=(ox or 0)*scale
				self.OffsetY=(oy or 0)*scale
			else
				self.OffsetX=(ox or 0)
				self.OffsetY=(oy or 0)
			end
			if(NPA_ScrollText_Config["ScrollText_AlphaByFrame"]==1)then
				modalpha=frame.ModuleMain:GetAlpha() or 1
			end
		end

		local step = self.TimeStack

		
		local alpha=(self.Life+0.1) / self.MaxLife * modalpha
		self:SetAlpha(alpha)

		self.X=self.X + self.StepX * step
		self.Y=self.Y + self.StepY * step
		self.StepY=self.StepY+self.AccY*step
		self.StepX=self.StepX+self.AccX*step


		if(self.Crit==1)then
			if(NPA_ScrollText_Config["ScrollText_Filter_StickCrit"]==1)then
				local sx=self.StepX
				local sy=self.StepY
				if(abs(sx)>0.1)then
					sx=sx*0.8
				else
					sx=0
				end
				if(abs(sy)>0.1)then
					sy=sy*0.8
				else
					sy=0
				end
				self.StepX=sx
				self.StepY=sy
			end
			if(NPA_ScrollText_Config["ScrollText_Filter_ShakeCrit"]==1)then
				local shakex=self.X+(random()-0.5)*2
				local shakey=self.Y+(random()-0.5)*2

				self:SetPoint("BOTTOMLEFT",UIParent,"BOTTOMLEFT",(self.OffsetX+self.X+shakex)/scale,(self.OffsetY+self.Y+shakey)/scale)
			else
				self:SetPoint("BOTTOMLEFT",UIParent,"BOTTOMLEFT",(self.OffsetX+self.X)/scale,(self.OffsetY+self.Y)/scale)
			end
		else
			self:SetPoint("BOTTOMLEFT",UIParent,"BOTTOMLEFT",(self.OffsetX+self.X)/scale,(self.OffsetY+self.Y)/scale)
		end

		self.Life = self.Life - step
	else
		self:Hide()
	end

	self.TimeStack=0
end
local function NPA_ScrollText_IconOnUpdate(self,elapsed)
	self.TimeStack=self.TimeStack+elapsed
	if(self.TimeStack<NPA_ScrollText_Config["ScrollText_UpdateInterval"])then
		return
	end

	local nTime=GetTime()
	local frame=GUIDToFrame[self.GUID]
	local show
	if(frame and frame:IsShown())then
		show=1
	end
	if((show or NPA_ScrollText_Config["ScrollText_HideByFrame"]~=1) and
		(abs(self.X-self.TargetX)>15 or abs(self.Y-self.TargetY)>15))then
		local modalpha=1
		local scale=UIParent:GetScale()
		if(show)then
			local tx,ty=frame:GetCenter()
			tx=tx or 0
			ty=ty or 0
			if(frame.IsTracker)then
				tx=tx*scale
				ty=ty*scale
			end
			self.TargetX=tx
			self.TargetY=ty

			if(NPA_ScrollText_Config["ScrollText_AlphaByFrame"]==1)then
				modalpha=frame.ModuleMain:GetAlpha() or 1
			end
		end

		self:SetAlpha(modalpha)

		self.X=self.X + (self.TargetX-self.X)/8
		self.Y=self.Y + (self.TargetY-self.Y)/8

		self:SetPoint("BOTTOMLEFT",UIParent,"BOTTOMLEFT",self.X/scale,self.Y/scale)

	else
		self:Hide()
	end

	self.TimeStack=0
end

local ManageTexture=NPA_Core.TextureManager2
local ManageFont=NPA_Core.FontManager

local function NPA_ScrollText_SetScroll(frame)
	frame:Hide()
	ManageFont(nil,frame.Text,NPA_ScrollText_Config["ScrollText_TextData"],"CENTER",frame,"CENTER")

	ManageFont(nil,frame.CritText,NPA_ScrollText_Config["ScrollText_CritTextData"],"CENTER",frame,"CENTER")

	ManageTexture(nil,frame.Icon,NPA_ScrollText_Config["ScrollText_IconData"],"RIGHT",frame.Text,"LEFT")
	ManageTexture(nil,frame.Overlay,NPA_ScrollText_Config["ScrollText_OverlayData"],"CENTER",frame.Icon,"CENTER")
	ManageTexture(nil,frame.Background,NPA_ScrollText_Config["ScrollText_BackgroundData"],"CENTER",frame.Icon,"CENTER")
	
	ManageTexture(nil,frame.CritIcon,NPA_ScrollText_Config["ScrollText_CritIconData"],"RIGHT",frame.CritText,"LEFT")
	ManageTexture(nil,frame.CritOverlay,NPA_ScrollText_Config["ScrollText_CritOverlayData"],"CENTER",frame.CritIcon,"CENTER")
	ManageTexture(nil,frame.CritBackground,NPA_ScrollText_Config["ScrollText_CritBackgroundData"],"CENTER",frame.CritIcon,"CENTER")
end
local function NPA_ScrollText_SetIcon(frame)
	frame:Hide()
	ManageTexture(nil,frame.Icon,NPA_ScrollText_Config["ScrollText_FlyingIconData"],"CENTER",frame,"CENTER")
	ManageTexture(nil,frame.Overlay,NPA_ScrollText_Config["ScrollText_FlyingOverlayData"],"CENTER",frame,"CENTER")
	ManageTexture(nil,frame.Background,NPA_ScrollText_Config["ScrollText_FlyingBackgroundData"],"CENTER",frame,"CENTER")
end

local function NPA_ScrollText_CreateIcon()
	local frame=CreateFrame("Frame","NPA_ScrollText_FlyingIconFrame",NPA_MainFrame)
	frame:SetScript("OnUpdate",NPA_ScrollText_IconOnUpdate)
	frame:SetHeight(1)
	frame:SetWidth(1)
	frame:Hide()
	frame.Icon=frame:CreateTexture(nil,"ARTWORK")
	frame.Overlay=frame:CreateTexture(nil,"OVERLAY")
	frame.Background=frame:CreateTexture(nil,"BACKGROUND")

	frame.TimeStack=0
	return frame
end

local function NPA_ScrollText_CreateScroll()
	local frame=CreateFrame("Frame","NPA_ScrollText_ScrollFrame",NPA_MainFrame)
	frame:SetHeight(1)
	frame:SetWidth(1)
	frame:Hide()

	frame.Text=frame:CreateFontString("NPA_ScrollText_Text","OVERLAY",nil)
	frame.Text:Show()

	frame.CritText=frame:CreateFontString("NPA_ScrollText_CritText","OVERLAY",nil)
	frame.CritText:Show()

	frame.Icon=frame:CreateTexture("NPA_ScrollText_Icon","ARTWORK",nil)
	frame.Icon:Show()

	frame.Overlay=frame:CreateTexture("NPA_ScrollText_Overlay","OVERLAY",nil)
	frame.Overlay:Show()

	frame.Background=frame:CreateTexture("NPA_ScrollText_Background","BACKGROUND",nil)
	frame.Background:Show()
	
	frame.CritIcon=frame:CreateTexture("NPA_ScrollText_CritIcon","ARTWORK",nil)
	frame.CritIcon:Show()

	frame.CritOverlay=frame:CreateTexture("NPA_ScrollText_CritOverlay","OVERLAY",nil)
	frame.CritOverlay:Show()

	frame.CritBackground=frame:CreateTexture("NPA_ScrollText_CritBackground","BACKGROUND",nil)
	frame.CritBackground:Show()

	frame.TimeStack=0
	
	frame:SetScript("OnUpdate",NPA_ScrollText_ScrollOnUpdate)

	NPA_ScrollText_SetScroll(frame)

	return frame
end


local NPA_ScrollText_PowerColor={
	[0]={r=0.00, g=0.00, b=1.00 }, --mana
	[1]={r=1.00, g=0.00, b=0.00 }, --rage
	[2]={r=1.00, g=0.50, b=0.25 }, --focus
	[3]={r=1.00, g=1.00, b=0.00 }, --enegry
	[4]={r=0.00, g=1.00, b=1.00 }, --happiness
	[5]={r=0.50, g=0.50, b=0.50 }, --rune
	[6]={r=0.00, g=0.82, b=1.00 }, --rune power
	[7]={r=0.50, g=0.32, b=0.55 }, --soul shard
	[8]={r=0.30, g=0.52, b=0.90 }, --lunar power
	[9]={r=0.95, g=0.90, b=0.60 }  --holy power
}

local function NPA_ScrollText_AddScroll(guid,spellid,text,spelltype,large,extratype)

	local frame=GUIDToFrame[guid]
	if(not(frame and frame:IsShown()))then
		return
	end
	
	local name,rank,icon
	if(spellid and spellid~=75 and spellid~=5019)then --override shoot /wand shoot
		name,rank,icon = GetSpellInfo(spellid)
	end


	if(NPA_ScrollText_Config["ScrollText_Filter_ShowSpellName"]==1 and name)then
		text=text.."("..name..")"
	end

	if(NPA_ScrollText_Config["ScrollText_Filter_ShowSpellRank"]==1 and rank)then
		text=text.."("..rank..")"
	end

	--debug
	--text=text..spellid

	
	local color
	if(extratype)then
		color=NPA_ScrollText_PowerColor[extratype] or {r=1,g=1,b=1}
	elseif(spelltype)then
		color=NPA_ScrollText_SpellTypeColor[spelltype] or {r=1,g=1,b=1}
	else
		color={r=1,g=1,b=1}
	end
	

	local scroll=NPA_ScrollText_Scrolls[NPA_ScrollText_ScrollCount]
	if(not scroll)then
		scroll=NPA_ScrollText_CreateScroll()
		NPA_ScrollText_Scrolls[NPA_ScrollText_ScrollCount]=scroll
	end

	NPA_ScrollText_ScrollCount=NPA_ScrollText_ScrollCount+1
	if(NPA_ScrollText_ScrollCount>NPA_ScrollText_Config["ScrollText_Max"])then
		NPA_ScrollText_ScrollCount=1
	end

	
	scroll.OffsetX,scroll.OffsetY=frame:GetCenter()
	scroll.X=NPA_ScrollText_Config["ScrollText_OffsetX"]
	scroll.Y=NPA_ScrollText_Config["ScrollText_OffsetY"]
	scroll.StepX=(random()-0.5) * NPA_ScrollText_Config["ScrollText_SpreadX"]+NPA_ScrollText_Config["ScrollText_SpeedX"]
	scroll.StepY=(random())*NPA_ScrollText_Config["ScrollText_SpreadY"]+NPA_ScrollText_Config["ScrollText_SpeedY"]
	scroll.AccX=NPA_ScrollText_Config["ScrollText_AccX"]
	scroll.AccY=NPA_ScrollText_Config["ScrollText_AccY"]
	scroll.Life=NPA_ScrollText_Config["ScrollText_Life"]
	scroll.GUID=guid
	scroll.MaxLife=NPA_ScrollText_Config["ScrollText_Life"]


	local st
	local si
	if(large==1)then
		scroll.Crit=1

		scroll.Text:Hide()
		scroll.Icon:Hide()
		scroll.Background:Hide()
		scroll.Overlay:Hide()

		scroll.CritText:Show()
		scroll.CritIcon:Show()
		scroll.CritBackground:Show()
		scroll.CritOverlay:Show()

		if(NPA_ScrollText_Config["ScrollText_Filter_StickCrit"]==1)then
			scroll.StepX=scroll.StepX*2
			scroll.AccX=0
			scroll.AccY=0
		end

		st=scroll.CritText
		si=scroll.CritIcon
	else
		scroll.Crit=nil

		scroll.Text:Show()
		scroll.Icon:Show()
		scroll.Background:Show()
		scroll.Overlay:Show()

		scroll.CritText:Hide()
		scroll.CritIcon:Hide()
		scroll.CritBackground:Hide()
		scroll.CritOverlay:Hide()

		st=scroll.Text
		si=scroll.Icon

	end
	st:SetText(text)
	st:SetTextColor(st.R*color.r,st.G*color.g,st.B*color.b)
	si:SetTexture(icon)

	scroll:Show()

end

	------------flying icon----------------
local function NPA_ScrollText_AddIcon(sourceGUID,destGUID,spellid)
	if(NPA_ScrollText_Config["ScrollText_FlyingIcon"]~=1 or (not spellid) or spellid==75 or spellid==5019)then --override shoot /wand shoot
		return
	end

	local _,_,icon=GetSpellInfo(spellid)

	local sourceframe=GUIDToFrame[sourceGUID]
	local destframe=GUIDToFrame[destGUID]
	if(icon
		and destframe and destframe:IsShown()
		and sourceframe and sourceframe:IsShown())then

		local flyingicon=NPA_ScrollText_Icons[NPA_ScrollText_IconCount]
		if(not flyingicon)then
			flyingicon=NPA_ScrollText_CreateIcon()
			NPA_ScrollText_Icons[NPA_ScrollText_IconCount]=scroll
		end

		NPA_ScrollText_IconCount=NPA_ScrollText_IconCount+1
		if(NPA_ScrollText_IconCount>NPA_ScrollText_Config["ScrollText_Max"])then
			NPA_ScrollText_IconCount=1
		end

		flyingicon.GUID=destGUID

		local sx,sy=sourceframe:GetCenter()
		sx=sx or 0
		sy=sy or 0

		local scale=UIParent:GetScale()

		if(sourceframe.IsTracker)then
			sx=sx*scale
			sy=sy*scale
		end

		flyingicon.X=sx
		flyingicon.Y=sy

		flyingicon.TargetX=sx+20
		flyingicon.TargetY=sy+20
		flyingicon:SetPoint("BOTTOMLEFT",UIParent,"BOTTOMLEFT",sx/scale,sy/scale)
		
		flyingicon.Icon:SetTexture(icon)

		flyingicon:Show()
	end
end


local NPA_ScrollText_CombatEventFunctions={
--               2             3          4       5    6       7    8        9     10   11   12   13   14   15   16   17    18                            
--_,event,_,combatevent ,sourceGUID, sourceName, _, destGUID, _, destFlags, arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8,arg9,arg10)
	[1]=function(name,uarg)
		local text
		if(NPA_ScrollText_Config["ScrollText_Filter_Absorb"]==1)then
			local absorb=uarg[12]+ uarg[13] + uarg[14]
			local a=uarg[10]
			if(type(a)=="number" and tonumber(a)>0)then
				absorb=absorb+a
			end
			if(absorb~=0)then
				text=" -"..uarg[9].."(-"..absorb..")"
			else
				text=" -"..uarg[9]
			end
		else
			text=" -"..uarg[9]
		end
		NPA_ScrollText_AddScroll(uarg[6],nil,text..name,nil,uarg[18])
	end,

	[2]=function(name,uarg)
		local text
		if(NPA_ScrollText_Config["ScrollText_Filter_Absorb"]==1)then
			local absorb=uarg[15]+ uarg[16]+ uarg[17]
			local a=uarg[10]
			if(type(a)=="number" and a>0)then
				absorb=absorb+a
			end

			if(absorb~=0)then
				text=" -"..uarg[12].."(-"..absorb..")"
			else
				text=" -"..uarg[12]
			end
		else
			text=" -"..uarg[12]
		end
		
		NPA_ScrollText_AddScroll(uarg[6],uarg[9],text..name,uarg[11],uarg[18])
	end,

	[3]=function(name,uarg)
		NPA_ScrollText_AddScroll(uarg[6],uarg[9]," +"..name,uarg[11])

	end,
	[4]=function(name,uarg)
		NPA_ScrollText_AddScroll(uarg[6],uarg[9]," -"..name,uarg[11])

	end,
	[5]=function(name,uarg)
		local absorb=uarg[13] + uarg[14]
		if(NPA_ScrollText_Config["ScrollText_HideFullOverHeal"]~=1 or uarg[12]>absorb)then
			local text
			if(NPA_ScrollText_Config["ScrollText_Filter_Absorb"]==1)then
				if(absorb~=0)then
					text=" +"..(uarg[12]-absorb).."("..absorb..")"
				else
					text=" +"..uarg[12]
				end
			else
				text=" +"..uarg[12]
			end
			NPA_ScrollText_AddScroll(uarg[6],uarg[9],text..name,uarg[11],uarg[15])
		end
	end,

--               2             3          4       5    6       7    8        9     10   11   12   13   14   15   16   17    18                            
--_,event,_,combatevent ,sourceGUID, sourceName, _, destGUID, _, destFlags, arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8,arg9,arg10)

	[6]=function(name,uarg)
		NPA_ScrollText_AddScroll(uarg[6],uarg[12]," X"..name,uarg[14],1)
	end,
	[7]=function(name,uarg)
		NPA_ScrollText_AddScroll(uarg[6],uarg[9]," +"..uarg[12],nil,nil,uarg[13])
	end,
	[8]=function(name,uarg)
		NPA_ScrollText_AddScroll(uarg[6],uarg[9]," X"..name,uarg[11],1)
	end,
}



local function NPA_ScrollText_OnEvent(uarg)
--               2             3          4       5    6         7      8      9     10   11   12   13   14   15   16   17    18                            
--_,event,_,combatevent ,sourceGUID, sourceName, flag, destGUID,name,destFlags,arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8,arg9,arg10)

	if(NPA_ScrollText_FlyingIconFilter[uarg[2]])then
		NPA_ScrollText_AddIcon(uarg[3],uarg[6],uarg[9])
	end

	--timestamp , event, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, 1spellID,2spellName,3spellSchool, 4amount, 5overkill,6 school, 7risisted, 8blocked, 9absorbed, 10critical, 11glancing,12 crushing
	--timestamp , event, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, 1amount, 2overkill, 3school, 4risisted, 5blocked, 6absorbed, 7cricital, 8glancing, 9crushing

	local eventfunc=NPA_ScrollText_CombatEventFunctions[NPA_ScrollText_CombatLogFilter[uarg[2]]]

	local myguid=UnitGUID("player") or 0
	
	if(eventfunc and uarg[6] and (uarg[6]~=myguid or NPA_ScrollText_Config["ScrollText_Filter_ShowOnSelf"]==1))then
		local focusguid=UnitGUID("focus") or -1
		local desthostile=bit_band(uarg[8],COMBATLOG_OBJECT_REACTION_HOSTILE)
		local targetguid=UnitGUID("target") or -2
		local show
		for _,func in pairs(NPA_ScrollText_OnEventFilterDest)do
			if(func(desthostile,uarg[6],targetguid,focusguid)==1)then
				show=1
				break
			end
		end
		if(show)then
			local petguid=UnitGUID("playerpet") or -3
				show=nil
				for _,func in pairs(NPA_ScrollText_OnEventFilterFrom)do
				if(func(uarg[3],myguid,petguid,focusguid,targetguid)==1)then
					show=1
					break
				end
			end
			if(show)then
				local name
				if(NPA_ScrollText_Config["ScrollText_Filter_ShowSelf"]==1 and (uarg[3]==myguid or uarg[3]==petguid))then
					name=" |cffff0000<--"
				elseif(NPA_ScrollText_Config["ScrollText_Filter_ShowCaster"]==1)then
					if(not uarg[4])then
						name="("..Localization["Unknow"]..")"
					else
						name="("..uarg[4]..")"
					end
				else
					name=""
				end	

				eventfunc(name,uarg)
			end
		end
	end
end



function NPA_ScrollText:Test()
	local crit,text
	if(random()>0.5)then
		crit=1
		text="(crit)"
	else
		crit=nil
		text="(normal)"
	end

	--(guid,spellid,text,spelltype,large,extratype)

	NPA_ScrollText_AddScroll(-100,33763,floor(random()*1000)..text,1,crit)
end


function NPA_ScrollText:ApplyConfig()
	NPA_Core:CheckConfigEntry("ScrollText",NPA_ScrollText_DefaultSetting)

	NPA_ScrollText_Config=NPA_Config["ScrollText"]

	NPA_ScrollText_BuildFilter()

	for i=1,NPA_ScrollText_Config["ScrollText_Max"] do
		if(not NPA_ScrollText_Scrolls[i])then
			NPA_ScrollText_Scrolls[i]=NPA_ScrollText_CreateScroll()
		end
		NPA_ScrollText_SetScroll(NPA_ScrollText_Scrolls[i])
	end

	for i=1,NPA_ScrollText_Config["ScrollText_Max"] do
		if(not NPA_ScrollText_Icons[i])then
			NPA_ScrollText_Icons[i]=NPA_ScrollText_CreateIcon()
		end
		NPA_ScrollText_SetIcon(NPA_ScrollText_Icons[i])
	end

	if(NPA_Config["Core"]["ScrollText"]==1)then
		NPA_Core.CombatEventFunc["ScrollText"]=NPA_ScrollText_OnEvent
	else
		NPA_Core.CombatEventFunc["ScrollText"]=nil
	end
end

NPA_Core:AddModule("ScrollText",NPA_ScrollText)