﻿-- Author      : Nogarder
-- Create Date : 2010/7/4 16:33:11

if(NPA_Core:CheckHook("NameText"))then


local Localization={}
local Tooltips={}
local locale=GetLocale()
local table_insert = table.insert
local pairs = pairs

if(locale=="zhTW")then
	Localization={
		["PageName"]="姓名文本",
		["NameByFaction"]="用陣營著色姓名",
		["BoldHostileName"]="不淡化敵對",
		["BoldNonHostileName"]="不淡化非敵對",
		["NameByClass"]="用職業著色姓名",
		["ShowGuild"]="顯示工會名",
		["HideWithHealthBar"]="血條淡化時也淡化",
		["ShowMark"]="顯示標記",
		["MarkTarget"]="標記我的目標",
		["MarkGuildMember"]="標記工會成員",
		["MarkFriend"]="標記我的好友",
		["MarkRaidMember"]="標記團隊成員",
		["MarkPartyMember"]="標記小隊成員",
		["MarkHideInInstance"]="副本中隱藏標記",
		["MarkColorByType"]="標記按類型上色",
		["ShowName"]="顯示姓名",
		["HideTotemName"]="隱藏圖騰名",
		["HideGuildInInstance"]="副本中隱藏工會",
		["MarkPartyAsRaid"]="在團隊中時將小隊標記為團隊",
		["Name"]="姓名",
		["Guild"]="工會",
		["Mark"]="標記",
		["FullName"]="顯示軍銜和頭銜",
		["Tapped"]="自定義屬於它人的怪物",
		["ShowHostilePortrait"]="顯示敵對目標頭像",
		["ShowNonHostilePortrait"]="顯示非敵對目標頭像",
		["ShowPartyPortrait"]="顯示小隊成員頭像",
		["ShowGuildPortrait"]="顯示工會成員頭像",
		["ShowRaidPortrait"]="顯示團隊成員頭像",
		["Portrait"]="頭像",
		["ShowPortrait"]="啟動頭像",
		["ShowOnlyPlayerPortrait"]="只顯示玩家頭像",
		["AutoHideGuild"]="姓名板不淡化時隱藏工會",
		["ColorTarget"]="著色目標名稱",
		["ColorFocus"]="著色focus名稱",
		["ColorMouseover"]="著色鼠標滑過名稱",
		["MarkFocus"]="標記focus",
		["MarkMouseover"]="標記鼠标滑过",
		["NameHostile"]="敵對姓名文本",
		["NameFriendly"]="友善姓名文本",
		["NameNeutral"]="中立姓名文本",
		["NameTapped"]="屬於它人的怪物的姓名文本",
		["SeparateNameText"]="使用按陣營分離的姓名文本設置",
		["Border"]="邊框",
		["Background"]="背景",
		["ShowBorder"]="顯示邊框",
		["ShowBackground"]="顯示背景",
		["NamePVPHostile"]="關閉pvp的敵方",
		["NamePVPFriendly"]="關閉pvp的友方",
		["ShowPVPHostile"]="自定義關閉pvp的敵方",
		["ShowPVPFriendly"]="自定義關閉pvp的友方",
		["ShowPVPFlag"]="顯示PvP標記",
		["PVPFlag"]="PvP標記",

		["HostilePlayerName"]="敵對玩家姓名",
		["NonHostilePlayerName"]="非敵對玩家姓名",
		["HostileNonPlayerName"]="敵對非玩家姓名",
		["NonHostileNonPlayerName"]="非敵對非玩家姓名",
		["QuestUnitName"]="任務單位姓名",
		["TargetName"]="目標姓名",
		["FocusName"]="Focus姓名",
		["MouseoverName"]="鼠標滑過姓名",

	}
	Tooltips={
		["NameText"]="顯示單位的姓名,工會,頭像,以及目標/鼠標滑過/focus的特殊標記"
	}
elseif(locale=="zhCN")then
	Localization={
		["PageName"]="姓名文本",
		["NameByFaction"]="用阵营着色姓名",
		["BoldHostileName"]="不淡化敌对",
		["BoldNonHostileName"]="不淡化非敌对",
		["NameByClass"]="用职业着色姓名",
		["ShowGuild"]="显示工会名",
		["HideWithHealthBar"]="当血条淡化时淡化",
		["ShowMark"]="显示标记",
		["MarkTarget"]="标记我的目标",
		["MarkGuildMember"]="标记工会成员",
		["MarkFriend"]="标记我的好友",
		["MarkRaidMember"]="标记团队成员",
		["MarkPartyMember"]="标记小队成员",
		["MarkHideInInstance"]="副本中隐藏标记",
		["MarkColorByType"]="标记按类型上色",
		["ShowName"]="显示姓名",
		["HideTotemName"]="隐藏图腾名",
		["HideGuildInInstance"]="副本中隐藏工会",
		["MarkPartyAsRaid"]="在团队中时将小队标记为团队",
		["Name"]="姓名",
		["Guild"]="工会",
		["Mark"]="标记",
		["FullName"]="显示军衔和头衔",
		["Tapped"]="自定义属于它人的怪物",
		["ShowHostilePortrait"]="显示敌对目标头像",
		["ShowNonHostilePortrait"]="显示其它非敌对目标头像",
		["ShowPartyPortrait"]="显示小队成员头像",
		["ShowGuildPortrait"]="显示工会成员头像",
		["ShowRaidPortrait"]="显示团队成员头像",
		["Portrait"]="头像",
		["ShowPortrait"]="启动头像",
		["ShowOnlyPlayerPortrait"]="只显示玩家头像",
		["AutoHideGuild"]="姓名板不淡化时隐藏工会",
		["ColorTarget"]="着色目标名称",
		["ColorFocus"]="着色focus名称",
		["ColorMouseover"]="着色鼠标滑过名称",
		["MarkFocus"]="标记focus",
		["MarkMouseover"]="标记鼠标滑过",
		["NameHostile"]="敌对姓名文本",
		["NameFriendly"]="友善姓名文本",
		["NameNeutral"]="中立姓名文本",
		["NameTapped"]="属于它人的怪物的姓名文本",
		["SeparateNameText"]="使用按阵营分离的姓名文本设置",
		["Border"]="边框",
		["Background"]="背景",
		["ShowBorder"]="显示边框",
		["ShowBackground"]="显示背景",
		["NamePVPHostile"]="关闭pvp的敌方",
		["NamePVPFriendly"]="关闭pvp的友方",
		["ShowPVPHostile"]="自定义关闭pvp的敌方",
		["ShowPVPFriendly"]="自定义关闭pvp的友方",
		["ShowPVPFlag"]="显示PvP标记",
		["PVPFlag"]="PvP标记",

		["HostilePlayerName"]="敌对玩家姓名",
		["NonHostilePlayerName"]="非敌对玩家姓名",
		["HostileNonPlayerName"]="敌对非玩家姓名",
		["NonHostileNonPlayerName"]="非敌对非玩家姓名",
		["QuestUnitName"]="任务单位姓名",
		["TargetName"]="目标姓名",
		["FocusName"]="Focus姓名",
		["MouseoverName"]="鼠标滑过姓名",

	}
	Tooltips={
		["NameText"]="显示单位的姓名,工会,头像,以及目标/鼠标滑过/focus的特殊标记"
	}
else
	Localization={
		["PageName"]="NameText",
		["NameByFaction"]="Color name by faction",
		["BoldHostileName"]="Don't fade hostile",
		["BoldNonHostileName"]="Don't fade non-hostile",
		["NameByClass"]="Color name by class",
		["ShowGuild"]="Show guild",
		["HideWithHealthBar"]="Fade with healthbar",
		["ShowMark"]="Show mark",
		["MarkTarget"]="Mark my target",
		["MarkGuildMember"]="Mark guild member",
		["MarkFriend"]="Mark my friend",
		["MarkRaidMember"]="Mark raid member",
		["MarkPartyMember"]="Mark party member",
		["MarkHideInInstance"]="Hide mark in instance",
		["MarkColorByType"]="Color mark by type",
		["ShowName"]="Show name",
		["HideTotemName"]="Hide totem name",
		["HideGuildInInstance"]="Hide guild in instance",
		["MarkPartyAsRaid"]="Mark party as raid if in raid",
		["Name"]="Name",
		["Guild"]="Guild",
		["Mark"]="Mark",
		["FullName"]="Show rank and title",
		["Tapped"]="Custom mob tapped by other player",
		["ShowHostilePortrait"]="Show hostile portrait",
		["ShowNonHostilePortrait"]="Show other non-hostile portrait",
		["ShowPartyPortrait"]="Show party member portrait",
		["ShowGuildPortrait"]="Show guild member portrait",
		["ShowRaidPortrait"]="Show raid member portrait",
		["Portrait"]="Portrait",
		["ShowPortrait"]="Show portrait",
		["ShowOnlyPlayerPortrait"]="Show only player portrait",
		["AutoHideGuild"]="Hide guild when nameplate not fading",
		["ColorTarget"]="Color target name",
		["ColorFocus"]="Color focus name",
		["ColorMouseover"]="Color mouseover name",
		["MarkFocus"]="Mark focus",
		["MarkMouseover"]="Mark mouseover",
		["NameHostile"]="Hostile nametext",
		["NameFriendly"]="Friendly nametext",
		["NameNeutral"]="Neutral nametext",
		["NameTapped"]="Mob tapped by other player nametext",
		["SeparateNameText"]="Use separated by faction nametext settings",
		["Border"]="Border",
		["Background"]="Background",
		["ShowBorder"]="Show border",
		["ShowBackground"]="Show background",

		["NamePVPHostile"]="Hostile with pvp off",
		["NamePVPFriendly"]="Friendly with pvp off",
		["ShowPVPHostile"]="Custom hostile with pvp off",
		["ShowPVPFriendly"]="Custom friendly with pvp off",
		["ShowPVPFlag"]="Show PvP flag",
		["PVPFlag"]="PvP flag",

		["HostilePlayerName"]="Hostile player name",
		["NonHostilePlayerName"]="Non-hostile player name",
		["HostileNonPlayerName"]="Hostile non-player name",
		["NonHostileNonPlayerName"]="Non-hostile non-player name",
		["QuestUnitName"]="Quest unit name",
		["TargetName"]="Target name",
		["FocusName"]="Focus name",
		["MouseoverName"]="Mouseover name",

	}
	Tooltips={
		["NameText"]="Show name,guild,portrait for unit, and special mark for target/mouseover/focus"
	}

end


local mainframe=NPA_Options:AddPage("NPA_Options_NameText",Localization["PageName"],"NameText",Tooltips["NameText"])

local Options=mainframe.Options


NPA_Options:CreateSliderEditButton(Localization["Name"],mainframe,"NameText_TextData",2,Options,1)
NPA_Options:CreateSliderEditButton(Localization["Guild"],mainframe,"NameText_GuildData",2,Options,2)

NPA_Options:CreateSliderEditButton(Localization["Mark"],mainframe,"NameText_MarkData",3,Options,3.5)

NPA_Options:CreateSliderEditButton(Localization["Portrait"],mainframe,"NameText_PortraitData",3,Options,5)

NPA_Options:CreateSliderEditButton(Localization["NameHostile"],mainframe,"NameText_TextHostileData",2,Options,7)
NPA_Options:CreateSliderEditButton(Localization["NameFriendly"],mainframe,"NameText_TextFriendlyData",2,Options,8)
NPA_Options:CreateSliderEditButton(Localization["NameNeutral"],mainframe,"NameText_TextNeutralData",2,Options,9)
NPA_Options:CreateSliderEditButton(Localization["NameTapped"],mainframe,"NameText_TextTappedData",2,Options,10)
NPA_Options:CreateSliderEditButton(Localization["NamePVPHostile"],mainframe,"NameText_TextPVPHostileData",2,Options,7,1)
NPA_Options:CreateSliderEditButton(Localization["NamePVPFriendly"],mainframe,"NameText_TextPVPFriendlyData",2,Options,8,1)

NPA_Options:CreateSliderEditButton(Localization["Border"],mainframe,"NameText_BorderData",1,Options,11.5)
NPA_Options:CreateSliderEditButton(Localization["Background"],mainframe,"NameText_BackgroundData",1,Options,12.5)

NPA_Options:CreateSliderEditButton(Localization["PVPFlag"],mainframe,"NameText_PVPFlagData",3,Options,12.5,1)
-----------------
local listframe=NPA_Options:CreateFrame("NPA_Options_NameText_Filter",mainframe)
listframe:SetPoint("TOPRIGHT",-6,-6)
listframe:SetHeight(360)
listframe:SetWidth(200)

local checkboxdata={
	["NameText_Name"]=Localization["ShowName"],
	["NameText_Guild"]=Localization["ShowGuild"],
	["NameText_Mark"]=Localization["ShowMark"],
	["NameText_HideTotemName"]=Localization["HideTotemName"],
	["NameText_HideGuildInInstance"]=Localization["HideGuildInInstance"],
	["NameText_AutoHideGuild"]=Localization["AutoHideGuild"],
}

NPA_Options:BuildCheckBoxList("NPA_Options_NameText",listframe,21,checkboxdata,17,Options,1)

local listframe4=NPA_Options:CreateFrame("NPA_Options_NameText_Filter",mainframe)
listframe4:SetPoint("TOPLEFT",listframe,"BOTTOMLEFT",0,3)
listframe4:SetPoint("TOPRIGHT",listframe,"BOTTOMRIGHT",0,3)

local checkboxdata={
	["NameText_BoldHostile"]=Localization["BoldHostileName"],
	["NameText_BoldNonHostile"]=Localization["BoldNonHostileName"],
	["NameText_FullName"]=Localization["FullName"],
	["NameText_Tapped"]=Localization["Tapped"],
	["NameText_ShowPVPHostile"]=Localization["ShowPVPHostile"],
	["NameText_ShowPVPFriendly"]=Localization["ShowPVPFriendly"],
	["NameText_SeparateNameText"]=Localization["SeparateNameText"],
	["NameText_ShowBorder"]=Localization["ShowBorder"],
	["NameText_ShowBackground"]=Localization["ShowBackground"],
}

NPA_Options:BuildCheckBoxList("NPA_Options_NameText",listframe4,21,checkboxdata,17,Options,1)


local listframe5=NPA_Options:CreateFrame("NPA_Options_NameText_Filter",mainframe)
listframe5:SetPoint("TOPLEFT",listframe4,"BOTTOMLEFT",0,3)
listframe5:SetPoint("TOPRIGHT",listframe4,"BOTTOMRIGHT",0,3)

local checkboxdata={
	["NameText_ShowHostilePortrait"]=Localization["ShowHostilePortrait"],
	["NameText_ShowNonHostilePortrait"]=Localization["ShowNonHostilePortrait"],
	["NameText_ShowPartyPortrait"]=Localization["ShowPartyPortrait"],
	["NameText_ShowRaidPortrait"]=Localization["ShowRaidPortrait"],
	["NameText_ShowGuildPortrait"]=Localization["ShowGuildPortrait"],
	["NameText_ShowPortrait"]=Localization["ShowPortrait"],
	["NameText_ShowOnlyPlayerPortrait"]=Localization["ShowOnlyPlayerPortrait"],
	["NameText_ShowPVPFlag"]=Localization["ShowPVPFlag"],
}

NPA_Options:BuildCheckBoxList("NPA_Options_NameText",listframe5,21,checkboxdata,17,Options,1)

local listframe3=NPA_Options:CreateFrame("NPA_Options_NameText_Filter2",mainframe)
listframe3:SetPoint("TOPLEFT",listframe5,"BOTTOMLEFT",0,3)
listframe3:SetPoint("TOPRIGHT",listframe5,"BOTTOMRIGHT",0,3)

local checkboxdata={
	["NameText_NameByClass"]=Localization["NameByClass"],
	["NameText_NameByFaction"]=Localization["NameByFaction"],
	["NameText_HideWithHealthBar"]=Localization["HideWithHealthBar"],
	["NameText_ColorTarget"]=Localization["ColorTarget"],
	["NameText_ColorFocus"]=Localization["ColorFocus"],
	["NameText_ColorMouseover"]=Localization["ColorMouseover"]
}
NPA_Options:BuildCheckBoxList("NPA_Options_NameText",listframe3,21,checkboxdata,17,Options,1)

local listframe2=NPA_Options:CreateFrame("NPA_Options_NameText_Filter3",mainframe)
listframe2:SetWidth(200)
listframe2:SetPoint("TOPRIGHT",listframe,"TOPLEFT",-3,0)

local checkboxdata={
	["NameText_MarkTarget"]=Localization["MarkTarget"],
	["NameText_MarkFriend"]=Localization["MarkFriend"],
	["NameText_MarkRaidMember"]=Localization["MarkRaidMember"],
	["NameText_MarkGuildMember"]=Localization["MarkGuildMember"],
	["NameText_MarkPartyMember"]=Localization["MarkPartyMember"],
	["NameText_MarkHideInInstance"]=Localization["MarkHideInInstance"],
	["NameText_MarkColorByType"]=Localization["MarkColorByType"],
	["NameText_MarkPartyAsRaid"]=Localization["MarkPartyAsRaid"],
	["NameText_MarkFocus"]=Localization["MarkFocus"],
	["NameText_MarkMouseover"]=Localization["MarkMouseover"],
}

NPA_Options:BuildCheckBoxList("NPA_Options_NameText",listframe2,21,checkboxdata,17,Options,1)



local listframe6=NPA_Options:CreateFrame("NPA_Options_NameText_Filter3",mainframe)
listframe6:SetWidth(350)
listframe6:SetPoint("BOTTOMLEFT",mainframe,"BOTTOMLEFT",3,3)

local checkboxdata={
	["NameText_HostilePlayerName"]=Localization["HostilePlayerName"],
	["NameText_NonHostilePlayerName"]=Localization["NonHostilePlayerName"],
	["NameText_HostileNonPlayerName"]=Localization["HostileNonPlayerName"],
	["NameText_NonHostileNonPlayerName"]=Localization["NonHostileNonPlayerName"],
	["NameText_QuestUnitName"]=Localization["QuestUnitName"],
	["NameText_TargetName"]=Localization["TargetName"],
	["NameText_FocusName"]=Localization["FocusName"],
	["NameText_MouseoverName"]=Localization["MouseoverName"],

}

NPA_Options:BuildCheckBoxList("NPA_Options_NameText2",listframe6,21,checkboxdata,17,Options,1)


end